%define gs_ver 8.63
%define gs_dot_ver 8.63

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	Ghostscript is a versatile processor for PostScript data with the ability to render PostScript to different targets.
Name:      	ghostscript
Version:   	8.63
Release:   	1
License: 	GNU/GPL
URL:		http://www.ghostscript.com/awki
Group:     	System/Configuration/Printing
Source0: 	ghostscript-%{gs_ver}.tar.bz2
Source2: 	CIDFnmap
Source4: 	cidfmap
Patch1: 	ghostscript-multilib.patch
Patch2: 	ghostscript-scripts.patch
Patch3: 	ghostscript-noopt.patch
Patch4: 	ghostscript-fPIC.patch
Patch5: 	ghostscript-runlibfileifexists.patch
Patch6: 	ghostscript-system-jasper.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot
Requires: 	urw-fonts >= 1.1, ghostscript-fonts
BuildRequires: 	libjpeg-devel, libXt-devel
BuildRequires: 	zlib-devel, libpng-devel, unzip, gtk2+-devel
BuildRequires: 	glib-devel, gnutls-devel
# Omni requires libxml
BuildRequires: 	libxml2-devel
BuildRequires: 	libtiff-devel
BuildRequires: 	cups-devel >= 1.1.13
BuildRequires: 	libtool
BuildRequires: 	jasper-devel
#BuildRequires: 	freetype-devel

%description
Ghostscript is a set of software that provides a PostScript(TM)
interpreter, a set of C procedures (the Ghostscript library, which
implements the graphics capabilities in the PostScript language) and
an interpreter for Portable Document Format (PDF) files. Ghostscript
translates PostScript code into many common, bitmapped formats, like
those understood by your printer or screen. Ghostscript is normally
used to display PostScript files and to print PostScript files to
non-PostScript printers.

If you need to display PostScript files or print them to
non-PostScript printers, you should install ghostscript. If you
install ghostscript, you also need to install the ghostscript-fonts
package.

%package	devel
Summary:	Files for developing applications that use ghostscript.
Requires:	%{name} = %{version}-%{release}
Group:		Development/Libraries

%description	devel
The header files for developing applications that use ghostscript.

%package	gtk
Summary:	A GTK-enabled PostScript(TM) interpreter and renderer.
Requires:	%{name} = %{version}-%{release}
Group:		Publishing

%description	gtk
A GTK-enabled version of Ghostscript, called 'gsx'.

%prep
%setup -q -n %{name}-%{gs_ver}
rm -rf libpng zlib jpeg jasper

# Fix ijs-config not to have multilib conflicts (bug #192672)
%patch1 -p1 -b .multilib

# Fix some shell scripts
%patch2 -p1 -b .scripts

# Build igcref.c with -O0 to work around bug #150771.
%patch3 -p1 -b .noopt

# Fix shared library build.
%patch4 -p1 -b .fPIC

# Define .runlibfileifexists.
%patch5 -p1 -b .runlibfileifexists

%patch6 -p1 -b .system-jasper

# Convert manual pages to UTF-8
from8859_1() {
	iconv -f iso-8859-1 -t utf-8 < "$1" > "${1}_"
	mv "${1}_" "$1"
}
for i in man/de/*.1; do from8859_1 "$i"; done

if [ -x autogen.sh ]; then
  ./autogen.sh
  pushd ijs
  ./autogen.sh
  popd
fi

%build
FONTPATH=
for path in \
	%{_datadir}/fonts/default/%{name} \
	%{_datadir}/fonts/default/Type1 \
	%{_datadir}/fonts/default/amspsfnt/pfb \
	%{_datadir}/fonts/default/cmpsfont/pfb \
	%{_datadir}/fonts \
	%{_datadir}/%{name}/conf.d \
	%{_sysconfdir}/%{name} \
	%{_sysconfdir}/%{name}/%{gs_dot_ver}
do
  FONTPATH="$FONTPATH${FONTPATH:+:}$path"
done
%configure --with-ijs --enable-dynamic --with-fontpath="$FONTPATH" \
	--with-drivers=ALL --disable-compile-inits

# Build IJS
cd ijs
automake --add-missing --copy || : # Ships with broken symlinks
%configure --enable-shared --enable-static
make
cd ..

make so RPM_OPT_FLAGS="$RPM_OPT_FLAGS" prefix=%{_prefix}
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" prefix=%{_prefix}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{%{_mandir},%{_bindir},%{_datadir},%{_docdir}}
mkdir -p $RPM_BUILD_ROOT/{%{_libdir},%{_includedir}/ijs}

make install soinstall \
%{?_with_freetype:FT_BRIDGE=1} \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	datadir=$RPM_BUILD_ROOT%{_datadir} \
	gsincludedir=$RPM_BUILD_ROOT%{_includedir}/ghostscript \
	bindir=$RPM_BUILD_ROOT%{_bindir} \
	libdir=$RPM_BUILD_ROOT%{_libdir} \
	docdir=$RPM_BUILD_ROOT%{_docdir}/%{name}-%{gs_dot_ver} \
	gsdir=$RPM_BUILD_ROOT%{_datadir}/%{name} \
	gsdatadir=$RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver} \
	gssharedir=$RPM_BUILD_ROOT%{_libdir}/%{name}/%{gs_dot_ver} \
	CUPSSERVERROOT=$RPM_BUILD_ROOT`cups-config --serverroot` \
	CUPSSERVERBIN=$RPM_BUILD_ROOT`cups-config --serverbin` \
	CUPSDATA=$RPM_BUILD_ROOT`cups-config --datadir`

mv -f $RPM_BUILD_ROOT%{_bindir}/gsc $RPM_BUILD_ROOT%{_bindir}/gs

cd ijs
%makeinstall
cd ..

echo ".so man1/gs.1" > $RPM_BUILD_ROOT/%{_mandir}/man1/ghostscript.1
ln -sf gs $RPM_BUILD_ROOT/usr/bin/ghostscript

# Rename an original cidfmap to cidfmap.GS
mv $RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver}/lib/cidfmap{,.GS}
# Install our own cidfmap to allow the separated
# cidfmap which the font packages own.
install -m0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver}/lib/CIDFnmap
install -m0644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver}/lib/cidfmap

# Header files.
mkdir -p $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -m0644 src/iapi.h $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -m0644 src/ierrors.h $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -m0644 src/errors.h $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -m0644 src/gdevdsp.h $RPM_BUILD_ROOT%{_includedir}/ghostscript

# Don't ship pkgconfig files.
rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/ijs.pc

# Don't ship ijs example client or server
rm -f $RPM_BUILD_ROOT%{_bindir}/ijs_{client,server}_example

# Don't ship files that get shipped in the cups package.
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/cups
rm -f $RPM_BUILD_ROOT%{_libdir}/cups/filter/pstoraster
rm -f $RPM_BUILD_ROOT/usr/lib/cups/filter/pstoraster

# Don't ship two copies of Resource.  Just the versioned one will do.
rm -rf $RPM_BUILD_ROOT%{_datadir}/ghostscript/Resource

# Don't ship URW fonts; we already have them.
rm -rf $RPM_BUILD_ROOT%{_datadir}/ghostscript/%{gs_dot_ver}/Resource/Font

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/conf.d
mkdir -p $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}
touch $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}/Fontmap.local
touch $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}/cidfmap.local
touch $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}/CIDFnmap.local

# The man/de/man1 symlinks are broken (bug #66238).
find $RPM_BUILD_ROOT%{_mandir}/de/man1 -type l | xargs rm -f

MAIN_PWD=`pwd`
(cd $RPM_BUILD_ROOT; find ./usr/share/ghostscript/%{gs_dot_ver}/lib -type f | \
		sed -e 's/\.//;' | grep -v lib/Fontmap* | grep -v gs_init.ps > $MAIN_PWD/rpm.sharelist
 find .%{_bindir}/ | sed -e 's/\.//;' | \
		grep -v '/$\|/hpijs$\|/gsx$\|/ijs-config$' \
		>> $MAIN_PWD/rpm.sharelist)

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f rpm.sharelist
%defattr(-,root,root)
%dir /etc/ghostscript
%dir /etc/ghostscript/%{gs_dot_ver}
%dir %{_datadir}/ghostscript
%dir %{_datadir}/ghostscript/conf.d
%dir %{_datadir}/ghostscript/%{gs_dot_ver}
%dir %{_datadir}/ghostscript/%{gs_dot_ver}/lib
%config %{_datadir}/ghostscript/%{gs_dot_ver}/lib/gs_init.ps
%config %{_datadir}/ghostscript/%{gs_dot_ver}/lib/Fontmap*
%{_datadir}/ghostscript/%{gs_dot_ver}/Resource/
%{_datadir}/ghostscript/%{gs_dot_ver}/examples
%{_mandir}/man*/*
%lang(de) %{_mandir}/de/man*/*
%doc %{_docdir}/%{name}-%{gs_dot_ver}
%{_libdir}/libgs.so.*
%{_libdir}/libijs-*.so*
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/%{gs_dot_ver}
/usr/lib/cups/filter/pstopxl
%{_datadir}/cups/model/pxl*
%config(noreplace) /etc/ghostscript/%{gs_dot_ver}/*

%files gtk
%defattr(-,root,root)
%{_bindir}/gsx

%files devel
%defattr(-,root,root)
%dir %{_includedir}/ghostscript
%{_includedir}/ghostscript/*.h
%dir %{_includedir}/ijs
%{_includedir}/ijs/*
%{_bindir}/ijs-config
%{_libdir}/libijs.so
%{_libdir}/libijs.*a
%{_libdir}/libgs.so

%changelog
* Fri Aug 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 8.63-1
- Version update
* Thu May 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 8.62-4
- rebuilt against gnutls 2.2.2
* Wed Mar 26 2008 Christian Wasem <wasem@ccux-linux.de> 8.62-3
- changed group of sub package gtk to Publishing
* Thu Mar 13 2008 Christian Metzen <metzench@ccux-linux.de> 8.62-2
- modified packaging
* Sat Mar 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 8.62-1
- Version update
* Thu Nov 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.61-1
- Version update
* Tue Aug 06 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.60-1
- Version update
* Sun May 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.57-1
- Version update
- switch to merged gnuified ghostscript
* Thu Mar 22 2007 Stefan Gottwald <gott@ccux-linux.de> 8.15.4-2
- Added Link /usr/include/ghostscript to /usr/include/ps
* Wed Mar 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.15.4-1
- Version update
* Fri Sep 29 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.15.3-1
- Version update
* Fri Aug 04 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.15.2-1
- Version update
* Tue Oct 05 2005 Christian Wasem <wasem@ccux-linux.de> 8.15.1-1
- Update to Version 8.15.1, added build and gtk2 patch
* Sun Jul 10 2005 Christian Metzen <metzench@ccux-linux.de> 7.07.1-5
- Rebuild missing devel package, tweaked specfile
* Sun Jul 10 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 7.07.1-4
- rebuilt against openssl 0.9.8
* Wed Nov 24 2004 Christian Metzen <metzench@ccux-linux.de> 7.07.1-3
- Removed Optimization
* Wed Nov 24 2004 Christian Metzen <metzench@ccux-linux.de> 7.07.1-2
- Initial Release
